import 'package:flutter_test/flutter_test.dart';
import 'package:openpay_flutter/model/card.dart';
import 'package:openpay_flutter/model/customer.dart';
import 'package:openpay_flutter/openpay_flutter.dart';

void main() {
  String _merchantId = 'ms9mpfws893d5w6hmpaj';
  String _privateKey = 'sk_976bba3e7bc4451da9261e45055ad829';
  String _uniqueid = DateTime.now().toUtc().millisecondsSinceEpoch.toString();
  Customer customer;
  Card _card;

  var openpay = OpenpayAPI(_merchantId, _privateKey);

  group('customer operations', () {
    test('create new customer', () async {
      Customer _customer = Customer();
      _customer.name = "Juan Flavio";
      _customer.last_name = "Valdes Garcia";
      _customer.email = "jvaldes.garcia@gmail.com";
      _customer.requires_account = false;
      _customer.external_id = _uniqueid;

      var result = await openpay.customerService.create(_customer);
      expect(_uniqueid, result.external_id);
      customer = result;
    });

    test('get customer by id', () async {
      var result = await openpay.customerService.get(Customer(), customer.id);
      expect(_uniqueid, result.external_id);
    });

    test('get customer by external id', () async {
      Map<String, String> filters = {
        "externalId": customer.external_id,
        "offset": "0",
        "limit": "1"
      };
      var result =
          await openpay.customerService.getList(Customer(), filters: filters);
      expect(result.length, 1);
    });

    test('update customer ', () async {
      customer.last_name = "valdes modificado";
      var result = await openpay.customerService.update(customer);
      expect(_uniqueid, result.external_id);
    });

    test('create customer card ', () async {
      Card card = Card();
      card.type = "debit";
      card.brand = "mastercard";
      card.cvv2 = "123";
      card.card_number = "4111111111111111";
      card.holder_name = "Juan Perez Ramirez";
      card.expiration_year = "20";
      card.expiration_month = "12";
      card.allows_charges = true;
      card.allows_payouts = false;
      card.creation_date = DateTime.now().toUtc();
      card.bank_name = "DESCONOCIDO";
      card.bank_code = "000";
      card.customer_id = customer.id;
      card.device_session_id = "a2b79p8xmzeyvmolqfja";
      card.points_card = true;
      customer.last_name = "valdes modificado";
      _card = await openpay.cardService.createCard(card);
      expect("411111XXXXXX1111", _card.card_number);
    });

    test('get customer card by id ', () async {
      var result = await openpay.cardService.getCustomerCard(customer.id, _card.id);
      expect(_card.id, _card.id);
    });

    /* test('update customer card ', () async {
      _card.last_name = "valdes modificado";
      var result = await openpay.customerService.update(customer);
      expect(_uniqueid, result.external_id);
    }); */

    test('get customer cards ', () async {             
      var result = await openpay.cardService.getCustomerCards(customer.id);
      expect(true,result.length>0);
    });
  });
}
